=== debian/changelog ===
devicexlib (0.1.0-2) unstable; urgency=medium

  * debian/rules, debian/libdevicexlib-dev.install: Install Fortran90 modules
    into /usr/include.

 -- Michael Banck <mbanck@debian.org>  Thu, 10 Nov 2022 21:16:20 +0100

devicexlib (0.1.0-1) unstable; urgency=medium

  * Initial upload.

 -- Michael Banck <mbanck@debian.org>  Fri, 31 Dec 2021 01:35:59 +0100
