## devicexlib 0.8.2

=== debian/changelog ===
devicexlib (0.8.2-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Fri, 29 Dec 2023 17:00:23 +0100

devicexlib (0.6.0-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Sat, 02 Dec 2023 18:27:47 +0100
