=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: Library wrapping device-oriented routines and utilities
  The deviceXlib library wraps device-oriented routines and utilities.
  .
