=== extlibs/Makefile ===
--- 
+++ 
@@ -4,7 +4,6 @@
 #===============================
 #
 -include ../make.inc
-
 
 #
 # MAIN target
@@ -22,7 +21,6 @@
 libblas_external:
 libblas_:
 
-
 #
 # lapack
 #
@@ -34,11 +32,8 @@
 liblapack_external:
 liblapack_:
 
+clean:
+	 if test -d blas ;         then ( cd blas;     $(MAKE) $@ ) ; fi
+	 if test -d lapack ;       then ( cd lapack;   $(MAKE) $@ ) ; fi
 
-#
-# cleaning
-#
-clean distclean:
-	 if test -d blas ;    then ( cd blas;    $(MAKE) $@ ) ; fi
-	 if test -d lapack ;  then ( cd lapack;  $(MAKE) $@ ) ; fi
-
+distclean: clean
