=== debian/changelog ===
devicexlib (0.8.5-2) unstable; urgency=medium

  * debian/patches/fix_ppc64le_configure.patch: New patch, fixes configure for
    ppc64le (Closes: #1077608).
  * debian/control (Build-Depends): Added architecture-is-64-bit (Closes:
    #1077607).
  * debian/rules (override_dh_auto_configure): Removed.
  * debian/rules (override_dh_auto_build): Run dh_auto_build rather $(MAKE)
    directly.

 -- Michael Banck <mbanck@debian.org>  Sun, 16 Mar 2025 15:46:28 +0100

devicexlib (0.8.5-1) unstable; urgency=medium

  * New upstream release.
  * debian/rules (override_dh_auto_configure): Output config.log if configure
    fails.

 -- Michael Banck <mbanck@debian.org>  Sat, 18 Jan 2025 10:48:41 +0100
