=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
-Build-Depends: debhelper (>> 12~),
+Build-Depends: architecture-is-64-bit,
+               debhelper (>> 12~),
                gfortran,
                libblas-dev,
                liblapack-dev
